<html>
<head>
<title>OgreColourValue.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreColourValue.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreColourValue_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _COLOURVALUE_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _COLOURVALUE_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00041"></a><a class="code" href="group__General.html#ga8c0fefd117985c6df93c4714f370bcd6">00041</a>     <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="group__General.html#ga8c0fefd117985c6df93c4714f370bcd6">RGBA</a>;
<a name="l00042"></a><a class="code" href="group__General.html#gaa329d9aeeafb7aa8ccc4f52fe4904e9f">00042</a>     <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="group__General.html#gaa329d9aeeafb7aa8ccc4f52fe4904e9f">ARGB</a>;
<a name="l00043"></a><a class="code" href="group__General.html#gac65e9a4f14f6cd3f76a1a9875fbd8dd8">00043</a>     <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="group__General.html#gac65e9a4f14f6cd3f76a1a9875fbd8dd8">ABGR</a>;
<a name="l00044"></a><a class="code" href="group__General.html#gaebed1ceefe1a5fb28f59ea894031680f">00044</a>     <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="group__General.html#gaebed1ceefe1a5fb28f59ea894031680f">BGRA</a>;
<a name="l00045"></a>00045 
<a name="l00057"></a><a class="code" href="classOgre_1_1ColourValue.html">00057</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00060"></a><a class="code" href="classOgre_1_1ColourValue.html#abc5d5f80d4d99438863cc808169283b5">00060</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1ColourValue.html#abc5d5f80d4d99438863cc808169283b5">ZERO</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1ColourValue.html#a7f8a06f2a9dd645417c36b560f496c1a">00061</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1ColourValue.html#a7f8a06f2a9dd645417c36b560f496c1a">Black</a>;
<a name="l00062"></a><a class="code" href="classOgre_1_1ColourValue.html#a8eba66b2908f44f00f8d9c9ec25877de">00062</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1ColourValue.html#a8eba66b2908f44f00f8d9c9ec25877de">White</a>;
<a name="l00063"></a><a class="code" href="classOgre_1_1ColourValue.html#ab9c2a36f53ac599850f1cf8b822f750d">00063</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1ColourValue.html#ab9c2a36f53ac599850f1cf8b822f750d">Red</a>;
<a name="l00064"></a><a class="code" href="classOgre_1_1ColourValue.html#a00384a789ac354ea8dd252c62cb17aa4">00064</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1ColourValue.html#a00384a789ac354ea8dd252c62cb17aa4">Green</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1ColourValue.html#a67ef25ecd0fa97e7e51e5bd87b29ae65">00065</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1ColourValue.html#a67ef25ecd0fa97e7e51e5bd87b29ae65">Blue</a>;
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="classOgre_1_1ColourValue.html#acc033c4828ad9f7469269933d24850f5">00067</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>( <span class="keywordtype">float</span> red = 1.0f,
<a name="l00068"></a>00068                     <span class="keywordtype">float</span> green = 1.0f,
<a name="l00069"></a>00069                     <span class="keywordtype">float</span> blue = 1.0f,
<a name="l00070"></a>00070                     <span class="keywordtype">float</span> alpha = 1.0f ) : r(red), g(green), b(blue), a(alpha)
<a name="l00071"></a>00071         { }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00074"></a>00074         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">00076</a>         <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a>,g,b,a;
<a name="l00077"></a>00077 
<a name="l00080"></a>00080         <a class="code" href="group__General.html#ga8c0fefd117985c6df93c4714f370bcd6">RGBA</a> getAsRGBA(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00081"></a>00081 
<a name="l00084"></a>00084         <a class="code" href="group__General.html#gaa329d9aeeafb7aa8ccc4f52fe4904e9f">ARGB</a> getAsARGB(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00085"></a>00085 
<a name="l00088"></a>00088         <a class="code" href="group__General.html#gaebed1ceefe1a5fb28f59ea894031680f">BGRA</a> getAsBGRA(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00089"></a>00089 
<a name="l00091"></a>00091         <a class="code" href="group__General.html#gac65e9a4f14f6cd3f76a1a9875fbd8dd8">ABGR</a> getAsABGR(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00092"></a>00092 
<a name="l00095"></a>00095         <span class="keywordtype">void</span> setAsRGBA(<span class="keyword">const</span> <a class="code" href="group__General.html#ga8c0fefd117985c6df93c4714f370bcd6">RGBA</a> val);
<a name="l00096"></a>00096 
<a name="l00099"></a>00099         <span class="keywordtype">void</span> setAsARGB(<span class="keyword">const</span> <a class="code" href="group__General.html#gaa329d9aeeafb7aa8ccc4f52fe4904e9f">ARGB</a> val);
<a name="l00100"></a>00100 
<a name="l00103"></a>00103         <span class="keywordtype">void</span> setAsBGRA(<span class="keyword">const</span> <a class="code" href="group__General.html#gaebed1ceefe1a5fb28f59ea894031680f">BGRA</a> val);
<a name="l00104"></a>00104 
<a name="l00107"></a>00107         <span class="keywordtype">void</span> setAsABGR(<span class="keyword">const</span> <a class="code" href="group__General.html#gac65e9a4f14f6cd3f76a1a9875fbd8dd8">ABGR</a> val);
<a name="l00108"></a>00108 
<a name="l00111"></a><a class="code" href="classOgre_1_1ColourValue.html#a21875c1d92c3ad0cba9cafd5776f42a0">00111</a>         <span class="keywordtype">void</span> saturate(<span class="keywordtype">void</span>)
<a name="l00112"></a>00112         {
<a name="l00113"></a>00113             <span class="keywordflow">if</span> (r &lt; 0)
<a name="l00114"></a>00114                 r = 0;
<a name="l00115"></a>00115             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (r &gt; 1)
<a name="l00116"></a>00116                 r = 1;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118             <span class="keywordflow">if</span> (g &lt; 0)
<a name="l00119"></a>00119                 g = 0;
<a name="l00120"></a>00120             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (g &gt; 1)
<a name="l00121"></a>00121                 g = 1;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123             <span class="keywordflow">if</span> (b &lt; 0)
<a name="l00124"></a>00124                 b = 0;
<a name="l00125"></a>00125             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (b &gt; 1)
<a name="l00126"></a>00126                 b = 1;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128             <span class="keywordflow">if</span> (a &lt; 0)
<a name="l00129"></a>00129                 a = 0;
<a name="l00130"></a>00130             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (a &gt; 1)
<a name="l00131"></a>00131                 a = 1;
<a name="l00132"></a>00132         }
<a name="l00133"></a>00133 
<a name="l00136"></a><a class="code" href="classOgre_1_1ColourValue.html#a2444beae59d41b61e71f45cc396ad34f">00136</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> saturateCopy(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00137"></a>00137 <span class="keyword">        </span>{
<a name="l00138"></a>00138             <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> ret = *<span class="keyword">this</span>;
<a name="l00139"></a>00139             ret.<a class="code" href="classOgre_1_1ColourValue.html#a21875c1d92c3ad0cba9cafd5776f42a0" title="Clamps colour value to the range [0, 1].">saturate</a>();
<a name="l00140"></a>00140             <span class="keywordflow">return</span> ret;
<a name="l00141"></a>00141         }
<a name="l00142"></a>00142 
<a name="l00144"></a><a class="code" href="classOgre_1_1ColourValue.html#a8a5e5d15068037cd9c3e3a13dd45b267">00144</a>         <span class="keyword">inline</span> <span class="keywordtype">float</span> operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )<span class="keyword"> const</span>
<a name="l00145"></a>00145 <span class="keyword">        </span>{
<a name="l00146"></a>00146             assert( i &lt; 4 );
<a name="l00147"></a>00147 
<a name="l00148"></a>00148             <span class="keywordflow">return</span> *(&amp;r+i);
<a name="l00149"></a>00149         }
<a name="l00150"></a>00150 
<a name="l00152"></a><a class="code" href="classOgre_1_1ColourValue.html#af3579c76f3cd365ac54454be6a3f6f89">00152</a>         <span class="keyword">inline</span> <span class="keywordtype">float</span>&amp; operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )
<a name="l00153"></a>00153         {
<a name="l00154"></a>00154             assert( i &lt; 4 );
<a name="l00155"></a>00155 
<a name="l00156"></a>00156             <span class="keywordflow">return</span> *(&amp;r+i);
<a name="l00157"></a>00157         }
<a name="l00158"></a>00158 
<a name="l00160"></a><a class="code" href="classOgre_1_1ColourValue.html#a5dde8a74df3cbfd55cb0e5ca90aafafe">00160</a>         <span class="keyword">inline</span> <span class="keywordtype">float</span>* ptr()
<a name="l00161"></a>00161         {
<a name="l00162"></a>00162             <span class="keywordflow">return</span> &amp;r;
<a name="l00163"></a>00163         }
<a name="l00165"></a><a class="code" href="classOgre_1_1ColourValue.html#ab081bc456d9b15bc3b0d3c8c4869cfad">00165</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">float</span>* ptr()<span class="keyword"> const</span>
<a name="l00166"></a>00166 <span class="keyword">        </span>{
<a name="l00167"></a>00167             <span class="keywordflow">return</span> &amp;r;
<a name="l00168"></a>00168         }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170         
<a name="l00171"></a>00171         <span class="comment">// arithmetic operations</span>
<a name="l00172"></a><a class="code" href="classOgre_1_1ColourValue.html#aba3d75622d5063ff08e5add5674a1914">00172</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> operator + ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00173"></a>00173 <span class="keyword">        </span>{
<a name="l00174"></a>00174             <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> kSum;
<a name="l00175"></a>00175 
<a name="l00176"></a>00176             kSum.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a> = r + rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a>;
<a name="l00177"></a>00177             kSum.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a> = g + rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a>;
<a name="l00178"></a>00178             kSum.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a> = b + rkVector.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a>;
<a name="l00179"></a>00179             kSum.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a> = a + rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a>;
<a name="l00180"></a>00180 
<a name="l00181"></a>00181             <span class="keywordflow">return</span> kSum;
<a name="l00182"></a>00182         }
<a name="l00183"></a>00183 
<a name="l00184"></a><a class="code" href="classOgre_1_1ColourValue.html#a16eb12d0c1eed21daae1553e6f200c01">00184</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> operator - ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00185"></a>00185 <span class="keyword">        </span>{
<a name="l00186"></a>00186             <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> kDiff;
<a name="l00187"></a>00187 
<a name="l00188"></a>00188             kDiff.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a> = r - rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a>;
<a name="l00189"></a>00189             kDiff.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a> = g - rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a>;
<a name="l00190"></a>00190             kDiff.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a> = b - rkVector.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a>;
<a name="l00191"></a>00191             kDiff.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a> = a - rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a>;
<a name="l00192"></a>00192 
<a name="l00193"></a>00193             <span class="keywordflow">return</span> kDiff;
<a name="l00194"></a>00194         }
<a name="l00195"></a>00195 
<a name="l00196"></a><a class="code" href="classOgre_1_1ColourValue.html#aeb6a68dbefba39f572fdbebe77228faa">00196</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>(<span class="keyword">const</span> <span class="keywordtype">float</span> fScalar )<span class="keyword"> const</span>
<a name="l00197"></a>00197 <span class="keyword">        </span>{
<a name="l00198"></a>00198             <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> kProd;
<a name="l00199"></a>00199 
<a name="l00200"></a>00200             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a> = fScalar*r;
<a name="l00201"></a>00201             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a> = fScalar*g;
<a name="l00202"></a>00202             kProd.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a> = fScalar*b;
<a name="l00203"></a>00203             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a> = fScalar*a;
<a name="l00204"></a>00204 
<a name="l00205"></a>00205             <span class="keywordflow">return</span> kProd;
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207 
<a name="l00208"></a><a class="code" href="classOgre_1_1ColourValue.html#ac2705420cbe5fa044bb757184f1f1c71">00208</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00209"></a>00209 <span class="keyword">        </span>{
<a name="l00210"></a>00210             <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> kProd;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a> = rhs.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a> * r;
<a name="l00213"></a>00213             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a> = rhs.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a> * g;
<a name="l00214"></a>00214             kProd.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a> = rhs.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a> * b;
<a name="l00215"></a>00215             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a> = rhs.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a> * a;
<a name="l00216"></a>00216 
<a name="l00217"></a>00217             <span class="keywordflow">return</span> kProd;
<a name="l00218"></a>00218         }
<a name="l00219"></a>00219 
<a name="l00220"></a><a class="code" href="classOgre_1_1ColourValue.html#a80871b6a2fe6b35f99e13d43e05aac0b">00220</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00221"></a>00221 <span class="keyword">        </span>{
<a name="l00222"></a>00222             <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> kProd;
<a name="l00223"></a>00223 
<a name="l00224"></a>00224             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a> = r / rhs.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a>;
<a name="l00225"></a>00225             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a> = g / rhs.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a>;
<a name="l00226"></a>00226             kProd.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a> = b / rhs.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a>;
<a name="l00227"></a>00227             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a> = a / rhs.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a>;
<a name="l00228"></a>00228 
<a name="l00229"></a>00229             <span class="keywordflow">return</span> kProd;
<a name="l00230"></a>00230         }
<a name="l00231"></a>00231 
<a name="l00232"></a><a class="code" href="classOgre_1_1ColourValue.html#aabe2f2e8307d487db930775de63c03e9">00232</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>(<span class="keyword">const</span> <span class="keywordtype">float</span> fScalar )<span class="keyword"> const</span>
<a name="l00233"></a>00233 <span class="keyword">        </span>{
<a name="l00234"></a>00234             assert( fScalar != 0.0 );
<a name="l00235"></a>00235 
<a name="l00236"></a>00236             <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> kDiv;
<a name="l00237"></a>00237 
<a name="l00238"></a>00238             <span class="keywordtype">float</span> fInv = 1.0f / fScalar;
<a name="l00239"></a>00239             kDiv.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a> = r * fInv;
<a name="l00240"></a>00240             kDiv.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a> = g * fInv;
<a name="l00241"></a>00241             kDiv.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a> = b * fInv;
<a name="l00242"></a>00242             kDiv.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a> = a * fInv;
<a name="l00243"></a>00243 
<a name="l00244"></a>00244             <span class="keywordflow">return</span> kDiv;
<a name="l00245"></a>00245         }
<a name="l00246"></a>00246 
<a name="l00247"></a><a class="code" href="classOgre_1_1ColourValue.html#a5b0ed5d4289ec1f56295380a0a334e4f">00247</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>(<span class="keyword">const</span> <span class="keywordtype">float</span> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; rkVector )
<a name="l00248"></a>00248         {
<a name="l00249"></a>00249             <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> kProd;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a> = fScalar * rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a>;
<a name="l00252"></a>00252             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a> = fScalar * rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a>;
<a name="l00253"></a>00253             kProd.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a> = fScalar * rkVector.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a>;
<a name="l00254"></a>00254             kProd.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a> = fScalar * rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a>;
<a name="l00255"></a>00255 
<a name="l00256"></a>00256             <span class="keywordflow">return</span> kProd;
<a name="l00257"></a>00257         }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259         <span class="comment">// arithmetic updates</span>
<a name="l00260"></a><a class="code" href="classOgre_1_1ColourValue.html#a8da50314432c59dee0aa3e6a72183e34">00260</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; rkVector )
<a name="l00261"></a>00261         {
<a name="l00262"></a>00262             r += rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a>;
<a name="l00263"></a>00263             g += rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a>;
<a name="l00264"></a>00264             b += rkVector.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a>;
<a name="l00265"></a>00265             a += rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a>;
<a name="l00266"></a>00266 
<a name="l00267"></a>00267             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00268"></a>00268         }
<a name="l00269"></a>00269 
<a name="l00270"></a><a class="code" href="classOgre_1_1ColourValue.html#abbc9a8f5cc1c054eb5b4633d6b0b2262">00270</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; rkVector )
<a name="l00271"></a>00271         {
<a name="l00272"></a>00272             r -= rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a>;
<a name="l00273"></a>00273             g -= rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a>;
<a name="l00274"></a>00274             b -= rkVector.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a>;
<a name="l00275"></a>00275             a -= rkVector.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a>;
<a name="l00276"></a>00276 
<a name="l00277"></a>00277             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00278"></a>00278         }
<a name="l00279"></a>00279 
<a name="l00280"></a><a class="code" href="classOgre_1_1ColourValue.html#aebee8d25bcd490889866a0ad94940ef7">00280</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; operator *= (<span class="keyword">const</span> <span class="keywordtype">float</span> fScalar )
<a name="l00281"></a>00281         {
<a name="l00282"></a>00282             r *= fScalar;
<a name="l00283"></a>00283             g *= fScalar;
<a name="l00284"></a>00284             b *= fScalar;
<a name="l00285"></a>00285             a *= fScalar;
<a name="l00286"></a>00286             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00287"></a>00287         }
<a name="l00288"></a>00288 
<a name="l00289"></a><a class="code" href="classOgre_1_1ColourValue.html#a3d17eedbff96cef8dbd4414183e15cb3">00289</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; operator /= (<span class="keyword">const</span> <span class="keywordtype">float</span> fScalar )
<a name="l00290"></a>00290         {
<a name="l00291"></a>00291             assert( fScalar != 0.0 );
<a name="l00292"></a>00292 
<a name="l00293"></a>00293             <span class="keywordtype">float</span> fInv = 1.0f / fScalar;
<a name="l00294"></a>00294 
<a name="l00295"></a>00295             r *= fInv;
<a name="l00296"></a>00296             g *= fInv;
<a name="l00297"></a>00297             b *= fInv;
<a name="l00298"></a>00298             a *= fInv;
<a name="l00299"></a>00299 
<a name="l00300"></a>00300             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00301"></a>00301         }
<a name="l00302"></a>00302 
<a name="l00308"></a>00308         <span class="keywordtype">void</span> setHSB(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> hue, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> saturation, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> brightness);
<a name="l00309"></a>00309 
<a name="l00315"></a>00315         <span class="keywordtype">void</span> getHSB(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* hue, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* saturation, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* brightness) <span class="keyword">const</span>;
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00321"></a>00321         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00322"></a><a class="code" href="classOgre_1_1ColourValue.html#a6e2f40ea1d31e17f5c45d457e0ab4b2d">00322</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; c )
<a name="l00323"></a>00323         {
<a name="l00324"></a>00324             o &lt;&lt; <span class="stringliteral">&quot;ColourValue(&quot;</span> &lt;&lt; c.r &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; c.g &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; c.b &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; c.a &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>;
<a name="l00325"></a>00325             <span class="keywordflow">return</span> o;
<a name="l00326"></a>00326         }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328     };
<a name="l00332"></a>00332 } <span class="comment">// namespace</span>
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
